library indicator;

import 'dart:core';
import 'api.dart';
import 'function.dart';
import 'variables.dart';
import 'dart:convert';
import 'package:geiger_api/geiger_api.dart';

void runIndicator(var indicatorID) async {

  final localMaster =
      (await getGeigerApi('', GeigerApi.masterId, Declaration.doNotShareData))!;
  Storage.controller = localMaster.getStorage();

  Storage.geigerIndicatorUUID = indicatorID;

  //await init();

  await checkExistNodes();

  await getMetrics(Types.users, Storage.userUUID);
  await getMetrics(Types.devices, Storage.deviceUUID);
  await getRecommendation();
  await getRisk();

  await updateScoreNode(Types.users, Types.geigerScoreUser);
  await updateScoreNode(Types.devices, Types.geigerScoreDevice);

  await updateRecommendationNode(Types.users);
  await updateRecommendationNode(Types.devices);

  getDevices();
  getEmployees();
  crtAggregateScore();
  await updateScoreNode(Types.users, Types.geigerScoreAggregate);

  updateScoreMSENode();

  var indicatorNode = {};

  indicatorNode[Types.geigerScoreUser] = JsonObject.geigerScoreUser;
  indicatorNode[Types.geigerScoreDevice] = JsonObject.geigerScoreDevice;
  indicatorNode[Types.geigerScoreAggregate] = JsonObject.geigerScoreAggregate;
  indicatorNode['userRecommandation'] = JsonObject.userRecoObjList;
  indicatorNode['deviceRecommandation'] = JsonObject.deviceRecoObjList;

  toJson(indicatorNode);
}

void toJson(var jsonObj) {
  // ignore: avoid_print
  print(jsonEncode(jsonObj));
}
